<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Native Client: Getting Started</title>
<link href="stylesheet.css" type="text/css" rel="stylesheet"></link>
</head>

<body>

<div id="toplink">
<a href="../README.html">Back to README</a>
</div>

<h1>Getting Started</h1>

<p>
This page tells you how to install Native Client
and run demos,
both in and outside of the browser.
On Linux and Mac OS X,
you can also recompile demos
and run them as standalone applications.
</p>

<p>
<b>Note:</b>
If you've already installed a previous version of the Native Client plug-in,
you don't need to uninstall it.
Just <a href="#software">get the software</a> and
<a href="#plugin">install the plug-in</a>.
</p>


<h3>Contents</h3>

<ul>
<li> <a href="#software">Get the software</a> </li>
<li> <a href="#example-nacl">Run an example as a Native Client app</a></li>
<li> <a href="#plugin">Install and use the plug-in</a></li>
<li> <a href="#make">Use make to compile and run standalone examples (Linux or Mac)</a></li>
<li> <a href="#next">What next?</a>
</ul>

<h2><a name="software" id="software"></a>Get the software</h2>

<p>
To run the examples as Native Client modules,
you need Native Client, Python,
and a browser &mdash;
we recommend Firefox 3.
If you want to develop your own Native Client modules,
you'll also need platform-specific development tools
such as Xcode on the Mac and Visual Studio on Windows,
as described in the platform details pages for
<a href="platform-linux.html">Linux</a>,
<a href="platform-mac.html">Mac</a>, and
<a href="platform-windows.html">Windows</a>.
</p>

<p class="technote">
<b>Technical detail:</b>
Native Client doesn't itself require Python.
We use Python for scripts
such as those that build and run examples
and that install the Native Client plug-in.
We're working on simpler installers that don't require Python.
</p>

<p>
Here's how to install Native Client and test your version of Python.
</p>

<ol>

<li>
<p>
Choose an installation directory (<em>install_dir</em>).
Because Native Client is frequently updated,
you might want a path that indicates the download or build date.
For example:
</p>

<ul>
<li>
<code>/home/me/NaCl/Testing/2009-02-11&nbsp;&nbsp;&nbsp;</code> <em>(Linux)</em>
</li>
<li>
<code>/Users/me/NaCl/Testing/2009-02-11&nbsp;&nbsp;</code> <em>(Mac)</em>
</li>
<li>
<code>C:\NaCl\Testing\2009-02-11&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code> <em>(Windows)</em>
</li>
</ul>

<p>
<b>Important:</b>
Make sure the full path of <em>install_dir</em> contains <b>no spaces</b>.
</p>
</li>

<li>
<p>
<a href="http://code.google.com/p/nativeclient/wiki/Downloads?tm=2">Download</a>
the Native Client <code>.tgz</code> or <code>.zip</code> file for your platform.
</p>
</li>

<li>
Extract the files into <em>install_dir</em>.
For example:

<p>Linux:</p>
<pre class="platform-linux">
<kbd>tar xvf nacl_linux*.tgz</kbd>
</pre>

<p>Mac:</p>
<pre class="platform-mac">
<kbd>tar xvf nacl_mac*.tgz</kbd>
</pre>

<p>
Windows:
</p>
<blockquote>
Do <em>not</em> use Cygwin unzip.
Instead, you can use the built-in Windows support or 7-Zip.
For example: In the file manager,
right-click the <code>nacl_windows_*.zip file</code>
and choose Extract All.
</blockquote>
</li>

<li>
<p>
Test your version of Python.
</p>

<pre class="platform-all">
<kbd>python -V</kbd>  <em>#Note: That's an uppercase 'V'</em>
</pre>

<p>
The output should be something like
<code>Python 2.4.3</code>.
If your system can't find <code>python</code>
or the version isn't 2.4 or 2.5,
get the right version of Python
and make sure it's in your path.
(2.6 might work, but we haven't tested it;
2.3 does <em>not</em> work.)
For more information, see the
details page for your platform &mdash;
<a href="platform-linux.html">Linux</a>,
<a href="platform-mac.html">Mac</a>, or
<a href="platform-windows.html">Windows</a>.
</p>

<p>
<b>Important:</b>
Make sure the full path to Python contains <b>no spaces</b>.
</p>

<p>
<b>Windows note (Cygwin):</b>
Do <b>not</b> use Cygwin's version of Python.
Instead, use the standard Python distribution.
For details, see the
<a href="platform-windows.html">Windows platform details page</a>.
</p>
</li>

</ol>


<h2><a name="example-nacl" id="example-nacl"></a>Run an example as a Native Client app</h2>

<p>
Now you'll learn how to run an example app in Native Client.
</p>

<p class="technote">
<b>Technical detail:</b>
You might be wondering why we start you off with a command-line application,
rather than with the browser.
The reason is that when you create your own Native Client modules,
it's easier to get started
if you're working outside the browser.
</p>

<ol>
<li>
<p>
In a terminal window, go to the earth demo's directory.
</p>

<p>
Linux or Mac:
</p>

<pre class="platform-linux-mac">
<kbd>cd <em>install_dir</em>/nacl/googleclient/native_client/tests/earth</kbd>
</pre>

<p>
Windows:
</p>

<pre class="platform-windows">
<kbd>cd <em>install_dir</em>\nacl\googleclient\native_client\tests\earth</kbd>
</pre>
</li>

<li>
<p>
Run the earth demo as a Native Client application:
</p>

<pre class="platform-all">
<kbd>python run.py</kbd>
</pre>

<p>
A window should appear
that contains a spinning, ray-traced globe.
The title of the window, <b>NaCl Application</b>,
indicates that you're running a Native Client module in a dedicated process.
</p>

<img src="images/NaClApp.jpg"
 width="512" height="534"
 alt="screenshot of the earth demo" />
<div class="caption">Figure: The earth demo running as a Native Client app (on Mac)</div>

<p>
You can quit the earth demo by clicking the close (X) button
in its window frame.
Or just wait; it quits automatically
after displaying 10000 frames.
</p>

<p>
<b>Troubleshooting:</b>
If no window appears
and you get a message starting with
<code>ERROR: Cannot find Native Client executable</code>,
you've probably downloaded the source-only distribution of Native Client.
You can either
<a href="http://code.google.com/p/nativeclient/wiki/Downloads?tm=2">download the distribution for your platform</a>
(Linux, Mac, or Windows)
or <a href="building.html">build Native Client and its SDK</a>.
</p>

<p class="comment">
[PENDING: What other problems have people run into?]
</p>
</li>
</ol>

<h2><a name="plugin" id="plugin"> </a> Install and use the plug-in </h2>

<p>
Now it's time to run some Native Client modules inside a browser.
To do so, you need to install the Native Client plug-in
and then load a page that refers to one or more Native Client modules.
</p>

<ol>
<li>
<p>
Go to the <code>native_client</code> directory.
</p>

<p>
Linux or Mac:
</p>

<pre class="platform-linux-mac">
<kbd>cd <em>install_dir</em>/nacl/googleclient/native_client</kbd>
</pre>

<p>
Windows:
</p>

<pre class="platform-windows">
<kbd>cd <em>install_dir</em>\nacl\googleclient\native_client</kbd>
</pre>
</li>

<li>
<p>
Bookmark this page,
both <a href="http://nativeclient.googlecode.com/svn/trunk/nacl/googleclient/native_client/documentation/getting_started.html">online</a>
and in your Native Client distribution
(<code><em>install_dir</em>/nacl/googleclient/native_client/documentation/getting_started.html</code>).
The bookmarks will make it easier for you to get back to these instructions
after restarting your browser.
Consider printing out this page, as well,
or saving these instructions to a text or PDF file.
</p>
</li>

<li>
<p>
Exit Firefox if you're running it.
Also exit any other browsers that might have run a Native Client module.
The plug-in might not install correctly if Firefox is running
or if any other browser is running a Native Client module.
</p>
</li>

<li>
<p>
Install the plug-in.
Answer <b>y</b> when asked whether you want to continue.
</p>

<p>
Linux or Mac:
</p>

<pre class="platform-linux-mac">
<kbd>./scons --prebuilt firefox_install</kbd>
...
Okay to continue? [y/n] <kbd>y</kbd>
...
</pre>

<p>
<b>64-bit Linux note:</b>
If you're using a 64-bit Linux system,
we recommend that you use a 32-bit browser.
An alternative is to use NSPluginWrapper.
For details, see the
<a href="platform-linux.html">Linux platform details page</a>.
</p>

<p>
Windows:
</p>

<pre class="platform-windows">
<kbd>.\scons.bat --prebuilt firefox_install</kbd>
...
Okay to continue? [y/n] <kbd>y</kbd>
...
</pre>

<p>
<b>Vista note:</b>
If UAC is enabled,
you can't use SCons to install the plug-in on Vista.
See the
<a href="platform-windows.html">Windows platform details page</a>
for alternate installation instructions.
</p>

<p class="technote">
<b>Technical detail:</b>
The <code>--prebuilt</code> option
isn't strictly necessary,
but it makes the install go much more quickly.
Without it, SCons attempts to rebuild some of the Native Client binaries.
</p>


<p class="comment">
[PENDING: Troubleshoot any likely problems.]
</p>
</li>

<li>
<p>
Look at the installer output
to make sure the installation was successful.
</p>
</li>

<li>
<p>
Launch Firefox and return to this page.
</p>
</li>

<a name="httpd"> </a>
<li>
<p>
Start up a local HTTP server,
if one isn't already running on your computer.
One way you can do this is by
launching <code>tools/httpd.py</code>
from the <code>native_client</code> directory.
</p>

<p>
<b>Note:</b>
Use Python 2.5 (not 2.4) to run <code>httpd.py</code>,
if possible.
If you use 2.4 and reload a module that has been recompiled,
you'll continue to see the old, cached version in your browser.
The reason is that 2.5 introduced support for a Last-Modified header.
If you must use 2.4, you can reload a changed module by either
bypassing your browser's cache
(see
<a href="http://en.wikipedia.org/wiki/Bypass_your_cache">http://en.wikipedia.org/wiki/Bypass_your_cache</a>)
or emptying the cache.
</p>

<p>Linux:</p>
<pre class="platform-linux">
<kbd>cd <em>install_dir</em>/nacl/googleclient/native_client</kbd>
<kbd>/usr/bin/python2.5 tools/httpd.py</kbd>
</pre>

<p>Mac:</p>

<pre class="platform-mac">
<kbd>cd <em>install_dir</em>/nacl/googleclient/native_client</kbd>
<kbd>python tools/httpd.py</kbd>
</pre>

<p>
Windows:
</p>

<pre class="platform-windows">
<kbd>cd <em>install_dir</em>\nacl\googleclient\native_client</kbd>
<kbd>python tools\httpd.py</kbd>
</pre>

<p class="technote">
<b>Technical detail:</b>
You need a local HTTP server because,
for now,
Native Client uses a whitelist
that ensures that module URLs
begin with <code>http://localhost</code>.
If you want to use other URLs,
you can modify the Native Client whitelist,
rebuild Native Client,
and install the new build.
For details,
see the <a href="http://code.google.com/p/nativeclient/wiki/FAQ">FAQ</a>.
</p>
</li>

<a name="browsertestpage"> </a>
<li>
<p>
In Firefox, visit the browser test page
(<code>native_client/scons-out/nacl/staging/examples.html</code>),
using a URL that begins with <code>http://localhost</code>.
If you're using <code>httpd.py</code>,
as shown in the previous step,
then here's the URL you'll need:
</p>

<blockquote>
<a href="http://localhost:5103/scons-out/nacl/staging/examples.html"
   target="_blank">http://localhost:5103/scons-out/nacl/staging/examples.html</a>
</blockquote>
</li>

<li>
<p>
Click the bottom-left link to go to the Mandelbrot viewer page.
That page has a Native Client implementation
of a Mandelbrot drawing.
You should see something like this:
</p>

<p>
<img src="images/mandelbrot.jpg"
 width="587" height="536"
 border="1"
 alt="screenshot of the Mandelbrot viewer demo" />
</p>
<div class="caption">Figure: The Mandelbrot viewer demo</div>

<p>
Play with the demo.
You can click the Cycle Colors button to see an everchanging display of colors.
Press and hold the + button to zoom in.
Use the arrows on the large round button to
change which part of the Mandelbrot you can see.
</p>

</li>

</ol>

<p>
For information about the other demos you can run in your browser, see
<a href="examples.html">Examples and Tests</a>.
</p>

<h2><a name="make" id="make"> </a> Use make to compile and run standalone examples (Linux or Mac)</h2>

<p>
In this section, you'll use GNU <code>make</code>
to compile and run the same example that you've already run.
First, you'll make a version that runs as a standalone application.
Next, you'll use <code>make</code>
to recompile the example and run it again as a Native Client app,
using the binaries that you created instead of prebuilt binaries.
Finally, you'll use <code>make clean</code>
and run the Native Client app again using the prebuilt binaries.
</p>

<p class="technote">
<b>Technical detail:</b>
The standard build tool for Native Client is
SCons, not make.
You can compile our examples (on any platform) using SCons,
following the instructions in
<a href="building.html">Building Native Client</a>.
The Makefiles exist so that
you can more easily use our examples
as templates for your own programs,
and so you can run our examples
as either Native Client or standalone applications (on Linux and Mac).
Running a module as a standalone application
can be handy when you're
<a href="debugging.html">debugging</a>.
</p>

<p>
To perform the steps in this section,
your development environment needs to be set up
as described in the details page for your platform
(<a href="platform-linux.html">Linux</a> or
<a href="platform-mac.html">Mac</a>).
Native Client doesn't support <code>make</code> or standalone apps on Windows.
</p>

<ol>
<li>
<p>
In a terminal window, go to the earth demo's directory:
</p>

<pre class="platform-linux-mac">
<kbd>cd <em>install_dir</em>/nacl/googleclient/native_client/tests/earth</kbd>
</pre>
</li>

<li>
<p>
Recompile the demo as a standalone application and run it.
</p>

<pre class="platform-linux-mac">
<kbd>make debug run</kbd>
</pre>

<p>
Just like before,
you should see a window with
a spinning globe.
This time, the title of the window is <b>Standalone Application</b>.
You'll also see the <code>g++</code> command
used to compile the demo as an app.
</p>

<p class="comment">
[PENDING: Troubleshoot any likely problems &mdash; e.g. make missing
on a Mac that doesn't have Xcode installed.]
</p>
</li>

<li>
<p>
Recompile the demo as a Native Client module and run it again:
</p>

<pre class="platform-linux-mac">
<kbd>make release nacl run</kbd>
</pre>

<p>
Again you should see a spinning globe
with the title <b>NaCl Application</b>.
You'll also see the <code>nacl-g++</code> command
that compiles the demo
and the <code>sel_ldr</code> command
that runs it in the Native Client environment.
</p>

<li>
<p>
Remove the binaries you built,
and use the prebuilt binaries
to run the example again as a Native Client module.
</p>

<pre class="platform-linux-mac">
<kbd>make clean</kbd>
<kbd>python run.py</kbd>
</pre>

<p>
You can still run the example after running <code>make clean</code>
because the Makefile refers to binaries in the current directory.
The Python script, on the other hand,
refers to binaries
that are in the <code>scons-out/nacl/staging</code> directory
(which is under <code>nacl/googleclient/native_client</code>).
The binaries under <code>scons-out</code>
are prebuilt for you,
but you can always rebuild using SCons,
as described in
<a href="building.html">Building Native Client</a>.
</p>

</li>
</ol>

<h2><a name="next" id="next"></a>What next?</h2>

<p>
Please try these:
</p>

<ul>
<li> Run all the
     <a href="examples.html">examples and tests</a>. </li>
<li> <a href="building.html">Build Native Client</a>
     from scratch. </li>
<li> Build Quake and XaoS for Native Client;
     run them.
     For instructions, see the <code>README.nacl</code> files under
     <code>nacl/googleclient/native_client/tests/quake</code> and
     <code>nacl/googleclient/native_client/tests/xaos</code>.</li>
<li> Browse the <a href="../README.html">documentation</a>, including the
     <a href="nacl_paper.pdf">Native Client paper</a> [PDF].</li>
<li> Browse the project site,
     <a href="http://code.google.com/p/nativeclient">http://code.google.com/p/nativeclient</a>,
     including the
     <a href="http://code.google.com/p/nativeclient/wiki">wiki</a>.</li>
</ul>

<p>
For even more fun, consider:
</p>

<ul>
<li> Port existing open-source packages to run as
     Native Client module components. </li>
<li> Write new Native Client modules that use
     Native Client's reduced system call interface, NPAPI, and SRPC
     to communicate with the browser. </li>
<li> Defeat the NaCl sandbox.
     Can you create a NaCl module
     that creates a file in the local file system
     or otherwise directly executes a system call?
     Exploits using <code>sel_ldr</code> from the command line
     or from the browser plug-in are both of interest.
     Don't use the <code>-d</code> debug flag &mdash;
     that would be too easy.
     For more suggestions and details,
     see the wiki page
     <a href="http://code.google.com/p/nativeclient/wiki/WhatToTest">WhatToTest</a>.
     </li>
</ul>

<p>
And please participate in the Native Client community:
</p>

<ul>
<li> Join the
     <a href="http://groups.google.com/group/native-client-discuss">discussion
     group</a> and the
     <a href="http://groups.google.com/group/native-client-announce">announcement
     group</a>.</li>
<li> <a href="http://code.google.com/p/nativeclient/issues">File issues</a>
     about any Native Client problems you've noticed
     or features you'd like.</li>
</ul>

<p id="license">
Except as otherwise
<a href="http://code.google.com/policies.html#restrictions">noted</a>,
the content of this page is licensed under a
<a href="http://creativecommons.org/licenses/by/2.5/">Creative Commons
Attribution 2.5 license</a>.
</p>

</body>
</html>
